#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Mar 26 14:44:13 2023

@author: anton
"""

from SLiCAP import *

fileName = "biasingConceptTransmitter"
specFileName = "specifications.csv"
# import the specifications
specs = csv2specs(specFileName)


i1 = instruction()
i1.setCircuit(fileName + ".cir")
specs2circuit(specs, i1)

htmlPage("Circuit data")
head2html("Circuit diagram")
img2html(fileName + ".svg", 800)
netlist2html(fileName + ".cir")
elementData2html(i1.circuit)
params2html(i1.circuit)

i1.setSimType("symbolic")
i1.setDataType("dcvar")
i1.setGainType("vi")
i1.setDetector("V_out")
result = i1.execute()

htmlPage("DC variance analysis")
dcVar2html(result)