#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Mar 27 13:59:57 2023

@author: anton
"""

from SLiCAP import *

fileName     = "feedbackModelTransmitter"
specFileName = "specifications.csv"

# import the specifications
specs = csv2specs(specFileName)

i1 = instruction()
i1.setCircuit(fileName + ".cir")
# Define the circuit parameters from the specifications
specs2circuit(specs, i1)
i1.defPar('R_ds', 300) # Reduce parallel resistance for phantom-zero compensation
htmlPage("Circuit Data")
head2html("Circuit diagram")
img2html(fileName + ".svg", 600)
netlist2html(fileName + ".cir")
elementData2html(i1.circuit)
params2html(i1.circuit)

i1.setSource("V1")
i1.setDetector("I_L1")
i1.setLGref("E_O1")
i1.setSimType("numeric")
i1.setDataType("laplace")

i1.setGainType("asymptotic")
asympt = i1.execute()

i1.setGainType("loopgain")
lgain = i1.execute()

i1.setGainType("servo")
servo = i1.execute()

i1.setGainType("direct")
direct = i1.execute()

i1.setGainType("gain")
gain = i1.execute()

figMag = plotSweep("figFBmodelTx", "Asymptotic-gain model transmitter", [asympt, lgain, servo, direct, gain], 1, 1E6, 200, show = True)
htmlPage("Results")
fig2html(figMag, 600)