#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Mar 27 13:59:57 2023

@author: anton
"""

from SLiCAP import *

fileName     = "HearingLoopDynamic"
specFileName = "specifications.csv"

# import the specifications
specs = csv2specs(specFileName)

i1 = instruction()
i1.setCircuit(fileName + ".cir")
# Define the circuit parameters from the specifications
specs2circuit(specs, i1)
i1.defPar("R_i", 50)
i1.defPar("R_ds", 300) # Phantom-zero compensation Transmitter
htmlPage("Circuit Data")
head2html("Circuit diagram")
img2html(fileName + ".svg", 600)
netlist2html(fileName + ".cir")
elementData2html(i1.circuit)
params2html(i1.circuit)

i1.setSource("V1")
i1.setDetector("V_out")
i1.setSimType("numeric")
i1.setGainType("gain")
i1.setDataType("laplace")

gainH = i1.execute()
htmlPage("Results")
figMag = plotSweep("HearingLoopDynamicMag", "Mag(gain)", gainH, 1, 1E6, 100, show=True)
fig2html(figMag, 600)
i1.setDataType('pz')
pzResult = i1.execute()
pz2html(pzResult)
listPZ(pzResult)